apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: pkgbuild-rpm
  namespace: {{ buildns }}
spec:
  params:
  - default: {{ (opsimages | json_query("[?name=='jkagel'].image"))[0] }}
    description: RPM Packages Builder Base Image
    name: baseimage
    type: string
  - default: "{{ nexus_api_address | default('') }}"
    description: Nexus Repository Address
    name: nexusaddress
    type: string
  - default: "{{ nexus_rpm_repository | default('el') }}"
    description: Nexus RPM Repository Name
    name: nexusrepo
    type: string
  steps:
  - args:
    - -c
    - |
        . /usr/local/bin/set_runtime
        pkgname=`ls el | head -1 | sed 's|.spec$||'`
        git rev-parse --short HEAD >gitHash
        make createinitialarchive
        make createrpm
        awk '/^Release:/{print $2;exit;}' el/${pkgname}.spec | cut -d% -f1 >patchNumber
        awk '/^Version:/{print $2;exit;}' el/${pkgname}.spec >versionNumber
        if test "$NEXUS_USER" -a "$NEXUS_PASS"; then
            find ./ -type f -name '*.rpm' | while read f
                do
                    curl -u "$NEXUS_USER:$NEXUS_PASS" -k -X POST -H "Content-Type: multipart/form-data" --data-binary "@$f" \
                        "$(params.nexusaddress)/repository/$(params.nexusrepo)/"
                done
        fi
    command:
    - /bin/sh
    env:
    - name: NEXUS_PASS
      valueFrom:
        secretKeyRef:
          name: "{{ nexus_artifacts_secret | default('artifacts') }}"
          key: password
          optional: true
    - name: NEXUS_USER
      valueFrom:
        secretKeyRef:
          name: "{{ nexus_artifacts_secret | default('artifacts') }}"
          key: username
          optional: true
    name: build
    image: $(params.baseimage)
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_pkgbuild_cpu_limit }}"
        memory: {{ tekton_pkgbuild_memory_limit }}
      requests:
        cpu: "{{ tekton_pkgbuild_cpu_request }}"
        memory: {{ tekton_pkgbuild_memory_request }}
{% else %}
    resources: {}
{% endif %}
    workingDir: "$(workspaces.source.path)"
  workspaces:
  - name: source
